"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.  # noqa: E501

    The version of the OpenAPI document: 2.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from cohesity_sdk.cluster.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
)

def lazy_import():
    from cohesity_sdk.cluster.model.bond_member import BondMember
    from cohesity_sdk.cluster.model.interface_stats import InterfaceStats
    globals()['BondMember'] = BondMember
    globals()['InterfaceStats'] = InterfaceStats


class Interface(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.

      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.

    """

    allowed_values = {
        ('bonding_mode',): {
            'None': None,
            'ACTIVEBACKUP': "ActiveBackup",
            '802_3AD': "802_3ad",
        },
        ('role',): {
            'None': None,
            'PRIMARY': "Primary",
            'SECONDARY': "Secondary",
        },
        ('services',): {
            'None': None,
            'REPLICATIONSERVICE': "ReplicationService",
            'REMOTETUNNELSERVICE': "RemoteTunnelService",
            'CLUSTERDATASERVICE': "ClusterDataService",
            'AVAHIDISCOVERSERVICE': "AvahiDiscoverService",
        },
        ('speed',): {
            'None': None,
            '1GBIT/S': "1Gbit/s",
            '10GBIT/S': "10Gbit/s",
            '25GBIT/S': "25Gbit/s",
            '40GBIT/S': "40Gbit/s",
            '100GBIT/S': "100Gbit/s",
            'UNKNOWN': "Unknown",
        },
        ('type',): {
            'None': None,
            'PHYSICAL': "Physical",
            'BOND': "Bond",
            'BRIDGE': "Bridge",
            'GROUP': "Group",
            'VLAN': "Vlan",
            'VLANPHYSICAL': "VlanPhysical",
            'VLANBOND': "VlanBond",
            'VLANGROUP': "VlanGroup",
            'VLANBRIDGE': "VlanBridge",
            'INVALID': "Invalid",
        },
    }

    validations = {
    }

    additional_properties_type = None

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'bond_members': ([BondMember], none_type,),  # noqa: E501
            'bonding_mode': (str, none_type,),  # noqa: E501
            'default_route': (bool, none_type,),  # noqa: E501
            'gateway': (str, none_type,),  # noqa: E501
            'group': (str, none_type,),  # noqa: E501
            'id': (int, none_type,),  # noqa: E501
            'ipv6_gateway': (str, none_type,),  # noqa: E501
            'ipv6_static': (str, none_type,),  # noqa: E501
            'ipv6_subnet': (str, none_type,),  # noqa: E501
            'is_connected': (bool, none_type,),  # noqa: E501
            'is_up': (bool, none_type,),  # noqa: E501
            'mac_address': (str, none_type,),  # noqa: E501
            'mtu': (int, none_type,),  # noqa: E501
            'name': (str, none_type,),  # noqa: E501
            'role': (str, none_type,),  # noqa: E501
            'services': ([str], none_type,),  # noqa: E501
            'speed': (str, none_type,),  # noqa: E501
            'static_ip': (str, none_type,),  # noqa: E501
            'stats': (InterfaceStats,),  # noqa: E501
            'subnet': (str, none_type,),  # noqa: E501
            'type': (str, none_type,),  # noqa: E501
            'virtual_ip': (str, none_type,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None



    attribute_map = {
        'bond_members': 'bondMembers',  # noqa: E501
        'bonding_mode': 'bondingMode',  # noqa: E501
        'default_route': 'defaultRoute',  # noqa: E501
        'gateway': 'gateway',  # noqa: E501
        'group': 'group',  # noqa: E501
        'id': 'id',  # noqa: E501
        'ipv6_gateway': 'ipv6Gateway',  # noqa: E501
        'ipv6_static': 'ipv6Static',  # noqa: E501
        'ipv6_subnet': 'ipv6Subnet',  # noqa: E501
        'is_connected': 'isConnected',  # noqa: E501
        'is_up': 'isUp',  # noqa: E501
        'mac_address': 'macAddress',  # noqa: E501
        'mtu': 'mtu',  # noqa: E501
        'name': 'name',  # noqa: E501
        'role': 'role',  # noqa: E501
        'services': 'services',  # noqa: E501
        'speed': 'speed',  # noqa: E501
        'static_ip': 'staticIp',  # noqa: E501
        'stats': 'stats',  # noqa: E501
        'subnet': 'subnet',  # noqa: E501
        'type': 'type',  # noqa: E501
        'virtual_ip': 'virtualIp',  # noqa: E501
    }

    _composed_schemas = {}

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """Interface - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)

            bond_members ([BondMember], none_type): Bond member details for bond interface.. [optional]  # noqa: E501
            bonding_mode (str, none_type): Bonding mode if this interface is a bond.. [optional]  # noqa: E501
            default_route (bool, none_type): Specifies whether or not this interface is the default route.. [optional]  # noqa: E501
            gateway (str, none_type): Gateway of the interface.. [optional]  # noqa: E501
            group (str, none_type): Group to which this interface belongs.. [optional]  # noqa: E501
            id (int, none_type): Id of the interface.. [optional]  # noqa: E501
            ipv6_gateway (str, none_type): The IPv6 gateway of the interface.. [optional]  # noqa: E501
            ipv6_static (str, none_type): Static IPv6 of the interface.. [optional]  # noqa: E501
            ipv6_subnet (str, none_type): The IPv6 subnet of the interface.. [optional]  # noqa: E501
            is_connected (bool, none_type): Specifies whether or not this interface is connected.. [optional]  # noqa: E501
            is_up (bool, none_type): Specifies whether or not the interface is up.. [optional]  # noqa: E501
            mac_address (str, none_type): MAC address of the interface.. [optional]  # noqa: E501
            mtu (int, none_type): MTU of the interface.. [optional]  # noqa: E501
            name (str, none_type): The name of the interface.. [optional]  # noqa: E501
            role (str, none_type): Role of the interface.. [optional]  # noqa: E501
            services ([str], none_type): Types of services this interface is used for.. [optional]  # noqa: E501
            speed (str, none_type): Speed of the interface.. [optional]  # noqa: E501
            static_ip (str, none_type): Static IP of the interface.. [optional]  # noqa: E501
            stats (InterfaceStats): [optional]  # noqa: E501
            subnet (str, none_type): Subnet of the interface.. [optional]  # noqa: E501
            type (str, none_type): The type of the interface.. [optional]  # noqa: E501
            virtual_ip (str, none_type): Virtual IP of the interface.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)


        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)


