"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.  # noqa: E501

    The version of the OpenAPI document: 2.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from cohesity_sdk.helios.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
)


class HeliosAuditLog(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.

      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.

    """

    allowed_values = {
        ('source_type',): {
            'None': None,
            'CLUSTER': "cluster",
            'HELIOS': "helios",
        },
    }

    validations = {
    }

    additional_properties_type = None

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'details': (str, none_type,),  # noqa: E501
            'username': (str, none_type,),  # noqa: E501
            'domain': (str, none_type,),  # noqa: E501
            'source_type': (str, none_type,),  # noqa: E501
            'entity_name': (str, none_type,),  # noqa: E501
            'entity_type': (str, none_type,),  # noqa: E501
            'action': (str, none_type,),  # noqa: E501
            'timestamp_usecs': (int, none_type,),  # noqa: E501
            'ip': (str, none_type,),  # noqa: E501
            'is_impersonation': (bool, none_type,),  # noqa: E501
            'cluster_identifier': (str, none_type,),  # noqa: E501
            'cluster_name': (str, none_type,),  # noqa: E501
            'tenant_id': (str, none_type,),  # noqa: E501
            'tenant_name': (str, none_type,),  # noqa: E501
            'original_tenant_id': (str, none_type,),  # noqa: E501
            'original_tenant_name': (str, none_type,),  # noqa: E501
            'previous_record': (str, none_type,),  # noqa: E501
            'new_record': (str, none_type,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None



    attribute_map = {
        'details': 'details',  # noqa: E501
        'username': 'username',  # noqa: E501
        'domain': 'domain',  # noqa: E501
        'source_type': 'sourceType',  # noqa: E501
        'entity_name': 'entityName',  # noqa: E501
        'entity_type': 'entityType',  # noqa: E501
        'action': 'action',  # noqa: E501
        'timestamp_usecs': 'timestampUsecs',  # noqa: E501
        'ip': 'ip',  # noqa: E501
        'is_impersonation': 'isImpersonation',  # noqa: E501
        'cluster_identifier': 'clusterIdentifier',  # noqa: E501
        'cluster_name': 'clusterName',  # noqa: E501
        'tenant_id': 'tenantId',  # noqa: E501
        'tenant_name': 'tenantName',  # noqa: E501
        'original_tenant_id': 'originalTenantId',  # noqa: E501
        'original_tenant_name': 'originalTenantName',  # noqa: E501
        'previous_record': 'previousRecord',  # noqa: E501
        'new_record': 'newRecord',  # noqa: E501
    }

    _composed_schemas = {}

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """HeliosAuditLog - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)

            details (str, none_type): Specifies the change details of this audit log.. [optional]  # noqa: E501
            username (str, none_type): Specifies the username who made this audit log.. [optional]  # noqa: E501
            domain (str, none_type): Specifies the domain of user who made this audit log.. [optional]  # noqa: E501
            source_type (str, none_type): Specifies the source type for this audit log.. [optional]  # noqa: E501
            entity_name (str, none_type): Specifies the entity name.. [optional]  # noqa: E501
            entity_type (str, none_type): Specifies the entity type.. [optional]  # noqa: E501
            action (str, none_type): Specifies the action type of this audit log.. [optional]  # noqa: E501
            timestamp_usecs (int, none_type): Specifies a unix timestamp in micro seconds when the audit log was taken.. [optional]  # noqa: E501
            ip (str, none_type): Specifies the ip of user who made this audit log.. [optional]  # noqa: E501
            is_impersonation (bool, none_type): Specifies if the action is made through impersonation.. [optional]  # noqa: E501
            cluster_identifier (str, none_type): Specifies the cluster identifier for this audtit log. Format is of clusterId:clusterIncarnationId. . [optional]  # noqa: E501
            cluster_name (str, none_type): Specifies the cluster name for this audtit log.. [optional]  # noqa: E501
            tenant_id (str, none_type): Specifies the tenant id who made this audit log.. [optional]  # noqa: E501
            tenant_name (str, none_type): Specifies the tenant name who made this audit log.. [optional]  # noqa: E501
            original_tenant_id (str, none_type): Specifies the original tenant id who made this audit log.. [optional]  # noqa: E501
            original_tenant_name (str, none_type): Specifies the original tenant name who made this audit log.. [optional]  # noqa: E501
            previous_record (str, none_type): Specifies the record before the action is invoked. This will be returned only if verbose audit is enabled. . [optional]  # noqa: E501
            new_record (str, none_type): Specifies the record after the action is invoked. This will be returned only if verbose audit is enabled. . [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)


        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)


