"""
    Cohesity REST API

    Cohesity API provides a RESTful interface to access the various data management operations on Cohesity cluster and Helios.  # noqa: E501

    The version of the OpenAPI document: 2.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from cohesity_sdk.helios.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
)

def lazy_import():
    from cohesity_sdk.helios.model.mcm_tenant_profile import McmTenantProfile
    from cohesity_sdk.helios.model.tenant_access import TenantAccess
    globals()['McmTenantProfile'] = McmTenantProfile
    globals()['TenantAccess'] = TenantAccess


class IdpPrincipal(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.

      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.

    """

    allowed_values = {
        ('principal_type',): {
            'None': None,
            'USER': "User",
            'GROUP': "Group",
        },
    }

    validations = {
    }

    additional_properties_type = None

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'name': (str, none_type,),  # noqa: E501
            'idp_id': (int, none_type,),  # noqa: E501
            'principal_type': (str, none_type,),  # noqa: E501
            'roles': ([str],),  # noqa: E501
            'clusters': ([str],),  # noqa: E501
            'is_active': (bool, none_type,),  # noqa: E501
            'created_time_usecs': (int, none_type,),  # noqa: E501
            'last_updated_time_usecs': (int, none_type,),  # noqa: E501
            'effective_time_usecs': (int, none_type,),  # noqa: E501
            'expired_time_usecs': (int, none_type,),  # noqa: E501
            'sid': (str, none_type,),  # noqa: E501
            'profiles': ([McmTenantProfile],),  # noqa: E501
            'tenant_accesses': ([TenantAccess],),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None



    attribute_map = {
        'name': 'name',  # noqa: E501
        'idp_id': 'idpId',  # noqa: E501
        'principal_type': 'principalType',  # noqa: E501
        'roles': 'roles',  # noqa: E501
        'clusters': 'clusters',  # noqa: E501
        'is_active': 'isActive',  # noqa: E501
        'created_time_usecs': 'createdTimeUsecs',  # noqa: E501
        'last_updated_time_usecs': 'lastUpdatedTimeUsecs',  # noqa: E501
        'effective_time_usecs': 'effectiveTimeUsecs',  # noqa: E501
        'expired_time_usecs': 'expiredTimeUsecs',  # noqa: E501
        'sid': 'sid',  # noqa: E501
        'profiles': 'profiles',  # noqa: E501
        'tenant_accesses': 'tenantAccesses',  # noqa: E501
    }

    _composed_schemas = {}

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, name, idp_id, principal_type, *args, **kwargs):  # noqa: E501
        """IdpPrincipal - a model defined in OpenAPI

        Args:
            name (str, none_type): Specifies the name of the Principal.
            idp_id (int, none_type): Specifies the IDP of the IDP with which this principal is associated.
            principal_type (str, none_type): Specifies the type of this principal. It can be a 'User' or a 'Group'.

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)

            roles ([str]): Specifies a list of roles associated with this Principal.. [optional]  # noqa: E501
            clusters ([str]): Specifies a list of clusters associated with this Principal. They should be in a string with the format '{cluster ID}:{cluster incarnation ID}'.. [optional]  # noqa: E501
            is_active (bool, none_type): Specifies whether or not this principal is currently active.. [optional]  # noqa: E501
            created_time_usecs (int, none_type): Specifies the timestamp in microseconds since the epoch when this Principal was created.. [optional]  # noqa: E501
            last_updated_time_usecs (int, none_type): Specifies the timestamp in microseconds since the epoch when this Principal was updated.. [optional]  # noqa: E501
            effective_time_usecs (int, none_type): Specifies the starting timestamp in microseconds since the epoch when this principal will be able to log in.. [optional]  # noqa: E501
            expired_time_usecs (int, none_type): Specifies the timestamp in microseconds since the epoch when this principal will no longer be able to log in.. [optional]  # noqa: E501
            sid (str, none_type): Specifies the unique SID of the principal.. [optional]  # noqa: E501
            profiles ([McmTenantProfile]): Specifies the list of tenant profiles associated to this principal if any.. [optional]  # noqa: E501
            tenant_accesses ([TenantAccess]): Specifies the list of tenant access associated to this principal.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)


        self.name = name
        self.idp_id = idp_id
        self.principal_type = principal_type
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)


